% DEMjpeg0.M
% Perform DCT analysis of Lenna and calculate entropies of diff
% coded DC band and compare with no diff coding.

clear all
close all
qstep = 15;

global printon
printon = input('Write print files (0=no, 1=yes):');

% 1-D DCT matrix.
T = dctmat(8);

load lenna
X = X - 120;

disp('Doing DCT'); X=colxfm(colxfm(X,T)',T)'; 

X = regroup(X,8);

s0 = size(X)/8;
dccoefs = X(1:s0(1),1:s0(2));
figure; draw(dccoefs); drawnow

dcdiffs = diff([zeros(s0(1),1)  dccoefs]')';
figure; draw(dcdiffs); drawnow

[na,xa] = hist2d(round(dccoefs/qstep));

figure
setfig(gcf)
subplot(2,1,1)
e1=sum(entrop(na,xa));
axis([-90 90 0 0.25])
title(sprintf('Entropy histograms of DC coefficients for Qstep = %d',qstep))
xlabel(sprintf('Without differential coding, entropy = %.2f bits',e1));
drawnow

[na,xa] = hist2d(round(dcdiffs/qstep));
subplot(2,1,2)
e2=sum(entrop(na,xa));
axis([-90 90 0 0.25])
xlabel(sprintf('With differential coding, entropy = %.2f bits',e2));

if printon==1,
  print -deps \1ngk\tex\i8coding\i8jpeg0.eps
end
