echo off
% DEMO2A.M
% I8 Coding Course - Lecture 1, Spectrum Demonstrations:
% This 2A version writes bmp files and works with 64K colour windows.

clear all

load lenna
X = X - 128; % Remove DC bias.
si = size(X);

% Show 2-D FFT of Lenna.
% figure(2);
% Generate a half cosine window function in 1-D.
w1d = sin(([1:si(2)] - 0.5)*pi/si(2));
% draw(log10(fftshift(abs(fft2(X .* (w1d.' * w1d))))));
Y = log10(fftshift(abs(fft2(X .* (w1d.' * w1d)))));

Y = norm255(Y);
b24write(rgb2x(Y,Y,Y),'lensp1');

Y = norm255(X);
b24write(rgb2x(Y,Y,Y),'lenna1');


% Show variations in local 2-D spectra over Lenna. Use 32 x 32
% half-sine windowed spectra (no overlap).

blk = 32;
t = [1:blk]-1;

% Generate a half cosine window function in 2-D.
w1d = sin((t+0.5)*pi/blk);
w2d = w1d.' * w1d;

for col=1:blk:si(2),
  for row=1:blk:si(1),
    X(t+row,t+col) = fftshift(abs(fft2(w2d .* X(t+row,t+col))));
    X(row,t+col) = ones(1,blk);
    X(t+row,col) = ones(blk,1);
  end
end

Y = norm255(log10(X));
b24write(rgb2x(Y,Y,Y),'lensp2');

% Redraw lenna with block boundaries shown.
load lenna
for col=1:blk:si(2),
  for row=1:blk:si(1),
    X(row,t+col) = ones(1,blk);
    X(t+row,col) = ones(blk,1);
  end
end

Y = norm255(X);
b24write(rgb2x(Y,Y,Y),'lenna2');

% Now assemble all 4 images in demo1e.
clear all
grey = 256*257 + 1;
y = zeros(588,528) + grey*240;
t = 1:256;
y(t+4,t+4) = b24read('lenna1');
y(t+4,t+268) = b24read('lensp1');
y(t+298,t+4) = b24read('lenna2');
y(t+298,t+268) = b24read('lensp2');
b24write(y,'demo1e');

return
 
