% DEMODCT5.M
% Compare DCT entropies with Haar entropies.

global printon
% printon = input('Write print files (0=no, 1=yes):');
printon = 0;

load enthaar
load ent4
load ent8
load ent16

% Assemble the entropies for the level 1, 2, 3 and 4 Haar transforms.
e(1:2:7) = sum(ee(:,2:5));

% Assemble the entropies for the 2, 4, 8 and 16 point DCTs.
e(2) = e(1);
e(4) = mean(mean(ent4));
e(6) = mean(mean(ent8));
e(8) = mean(mean(ent16));

disp('Haar and DCT entropies:')
reshape(e,2,4)

% Plot the 8 entropies on a bar plot.
setfig(1)
subplot(1,1,1);
bar([1:8]',e,'y');
title('Mean Entropies for Haar Transforms and DCTs','FontSize',16);
ylabel('Entropy (bit/pel)','FontSize',16);
st = 0.5;
text(1,st,'Level 1 Haar','Rot',90);
text(3,st,'Level 2 Haar','Rot',90);
text(5,st,'Level 3 Haar','Rot',90);
text(7,st,'Level 4 Haar','Rot',90);
text(2,st,'2 x 2 DCT','Rot',90);
text(4,st,'4 x 4 DCT','Rot',90);
text(6,st,'8 x 8 DCT','Rot',90);
text(8,st,'16 x 16 DCT','Rot',90);
for i=1:8,
  text(i,e(i),sprintf('%.4f',e(i)),'horiz','center','vert','bot');
end
drawnow

if printon==1,
  print -deps \1ngk\tex\i8coding\i8dct51.eps
end

