% DEMWAV2a.M
% Display the results from DEMWAV2.M, and then display fig2.7d
% to show which images are quantised by what.

clear
global printon
% printon = input('Write print files (0=no, 1=yes, 2=GIF):');
printon = 0;

close all

load entdct8
% save entdct8 ent8a ent8m rmse X qstep T xfmstr
ent = ent8m;
figure(1)
draw(X)
set(gcf,'numbertitle','off','name',['Fig 1: ' xfmstr])
% pos=[xsize-scale*n+12-gcf*20 gcf*20-14 scale*n+4 scale*m+4];
pos=[80 188 516 516];
set(gcf,'position',pos);
drawnow
Y=X;
load lenna
rmserr = rms(rms(Y-X))
save res1 ent rmserr 
if printon==2,
  drawfile(Y,'\1ngk\tex\i8coding\i8dew1.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8dew1.eps
end

clear Y
load enthaar2
disp(xfmstr)
qstep
ee
sumee = sum(ee)
ent = [ent sumee(5)];
ents = ee(:,5);
figure(2)
draw(X)
set(gcf,'numbertitle','off','name',['Fig 2: ' xfmstr])
pos=[80+220 188 516 516];
set(gcf,'position',pos);
drawnow
Y=X;
load lenna
rmserr = [rmserr rms(rms(Y-X))]
save res1 ent rmserr 
if printon==2,
  drawfile(Y,'\1ngk\tex\i8coding\i8dew2.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8dew2.eps
end

clear Y
load entlegal
disp(xfmstr)
qstep
ee
sumee = sum(ee)
load res1
ent = [ent sumee(5)];
ents = [ents ee(:,5)];
figure(3)
draw(X)
set(gcf,'numbertitle','off','name',['Fig 3: ' xfmstr])
pos=[80+220*2 188 516 516];
set(gcf,'position',pos);
drawnow
Y=X;
load lenna
rmserr = [rmserr rms(rms(Y-X))]
save res1 ent rmserr 
if printon==2,
  drawfile(Y,'\1ngk\tex\i8coding\i8dew3.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8dew3.eps
end

clear Y
load entinleg
disp(xfmstr)
qstep
ee
sumee = sum(ee)
load res1
ent = [ent sumee(5)];
ents = [ents ee(:,5)];
figure(4)
draw(X)
set(gcf,'numbertitle','off','name',['Fig 4: ' xfmstr])
pos=[80 1 516 516];
set(gcf,'position',pos);
drawnow
Y=X;
load lenna
rmserr = [rmserr rms(rms(Y-X))]
save res1 ent rmserr 
if printon==2,
  drawfile(Y,'\1ngk\tex\i8coding\i8dew4.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8dew4.eps
end

clear Y
load ent_57
disp(xfmstr)
qstep
ee
sumee = sum(ee)
load res1
ent = [ent sumee(5)];
ents = [ents ee(:,5)];
figure(5)
draw(X)
set(gcf,'numbertitle','off','name',['Fig 5: ' xfmstr])
pos=[80+220 1 516 516];
set(gcf,'position',pos);
drawnow
Y=X;
load lenna
rmserr = [rmserr rms(rms(Y-X))]
save res1 ent rmserr 
if printon==2,
  drawfile(Y,'\1ngk\tex\i8coding\i8dew5.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8dew5.eps
end

clear Y
load ent_1319
disp(xfmstr)
qstep
ee
sumee = sum(ee)
load res1
ent = [ent sumee(5)];
ents = [ents ee(:,5)];
figure(6)
draw(X)
set(gcf,'numbertitle','off','name',['Fig 6: ' xfmstr])
pos=[80+220*2 1 516 516];
set(gcf,'position',pos);
drawnow
Y=X;
load lenna
qstep
rmserr = [rmserr rms(rms(Y-X))]
ent
save res1 ent rmserr 
if printon==2,
  drawfile(Y,'\1ngk\tex\i8coding\i8dew6.gif');
elseif printon==1,
  print -deps \1ngk\tex\i8coding\i8dew6.eps
end
clear Y

% Plot bar graphs of entropies.
csents = cumsum(ents);
setfig(7)
font = 16;
bar([1:5]',ents.','stacked');
hold on
plot([5.6;6.4],[1;1]*csents([3 6 9 13],5)',':k')
axis([0 7 0 0.5]);
ylabel('Entropy with RLC (bit/pel)','FontSize',font)
title(['Entropies of 4-level DWT Subimages for Qstep=50,100,200'],'FontSize',font);
ents = cumsum(ents);
text(1,ents(13,1)+0.01,'Haar','horiz','center','vert','bot');
text(2,ents(13,2)+0.01,'LeGall','horiz','center','vert','bot');
text(3,ents(13,3)+0.01,'Inv-LeGall','horiz','center','vert','bot');
text(4,ents(13,4)+0.01,'5,7-tap','horiz','center','vert','bot');
text(5,ents(13,5)+0.01,'13,19-tap','horiz','center','vert','bot');
text(6,ents(3,5)/2,'Level 1','horiz','center','vert','mid');
text(6,mean(ents([3 6],5)),'Level 2','horiz','center','vert','mid');
text(6,mean(ents([6 9],5)),'Level 3','horiz','center','vert','mid');
text(6,mean(ents([9 13],5)),'Level 4','horiz','center','vert','mid');
if printon==1,
  print -deps \1ngk\tex\i8coding\i8dew7.eps
end

% Now plot rate distortion results.
qstep2 = [
    40    80    80   160
    40    40    40    80];
rmserr2 = [
    9.6121    9.5098   10.9120    7.9321    8.4263    8.0420];
ent2 = [
    0.3433    0.4676    0.4590    0.4117    0.3935    0.3674];
setfig(8)
plot([ent;ent2],[rmserr;rmserr2],'-',[ent;ent2],[rmserr;rmserr2],'*');
axis([0 0.5 0 14]);
grid
xlabel('Entropy with RLC (bit/pel)','FontSize',font);
ylabel('RMS quantising error','FontSize',font);
title('Error vs entropy comparison for DCT and DWTs','FontSize',font);
text(ent(1),rmserr(1),'8x8 DCT ','vert','mid','horiz','right');
text(ent(2),rmserr(2),'Haar DWT','vert','bot','horiz','right');
text(ent(3),rmserr(3),'LeGall DWT ','vert','mid','horiz','right');
text(0.43,rmserr2(4),'LeGall Inv-DWT','vert','top','horiz','center');
text(ent(5),rmserr(5),'5,7-tap DWT ','vert','mid','horiz','right');
text(ent(6),rmserr(6),'13,19-tap DWT ','vert','top','horiz','right');
if printon==1,
  print -deps \1ngk\tex\i8coding\i8dew8.eps
end

% Now show fig 2.7d.
load fig27d
figure(9);
draw(max(min(X,200),-200));
set(gcf,'numbertitle','off','name','Fig 9: Wavelet subimages')

load lenna
figure; draw(X)
set(gcf,'numbertitle','off','name','Original Lenna','pos',[200 100 516 516])

return

