function enhance(figs)

% function enhance(figs)
% Adjust contrast and brightness of a grey-scale colour map
% for the figures in figs(:).
% Height of clicked pt above baseline increases contrast.
% Distance of pt to right of centre raises brightness.
% Press ctrl-C if the routine hangs.

% Nick Kingsbury, Feb 96.

figure(figs(1))

map = colormap;
n = size(map,1);

p = ([1:n]' - 0.5)/n - 0.5;


% Display loop: continue until an odd no of points is entered.
x = 0;y = 0;

while rem(size(x,1),2) == 1,
  [x,y] = getpts(figs(1));
  ax = axis;

  gain = 2^(2*(y(1) - ax(3))/(ax(4) - ax(3)));
  offset = (x(1) - ax(1))/(ax(2) - ax(1));
  map = min(max(gain * p + offset, 0), 1) * ones(1,3);

  for i=1:length(figs),
    figure(figs(i));
    colormap(map);
    drawnow
  end
end

return;

