function H = entlapl(q)
% function H = entlapl(q)
% Calculate the entropy of a matrix with laplacian PDF:
%    p(x) = \fracd{1}{2 x_0}~e^{-|x|/x_0}
% of standard  deviation sqrt(2)*x0, when the ratio of the quantiser
% step size to x0 is q.

alpha = sinh(q/2); 
r = exp(-q);
H0 = (sqrt(r)-1).*log(1-sqrt(r))/log(2);
H1 = -(2*alpha.*r./(1-r)).*(log(alpha) + log(r)./(1-r))/log(2); 
H = H0 + H1;

