function [ep,p] = entrop(nn,xx)

% function [ep,p] = entrop(nn,xx)
% Calculate the entropy components ep of a vector of histogram counts nn.
% The total entropy is sum(ep).
% If xx is given, plot the entropy histogram (normal histogram with
% counts weighted by -log2(p)/N so that the bar heights indicate the
% contribution to the entropy of each bar).

N = sum(nn);

% Convert nn to probabilities.
p = nn / N;

% Calculate the p*log(p) terms.
ep = p .* (-log(max(p,1e-20))/log(2));

if nargin > 1,
  m = length(xx);
%  bar([xx; 3*xx(m)-2*xx(m-1)],[ep; sum(ep)]);
  bar(xx,ep,'-y')
  hold on
  bar(xx,p,':c')
  hold off
%  xlabel(sprintf('Total entropy = %.3f bits.',sum(ep)));
%  drawnow
end

return;
