function y = extend(x, n)
% function y = extend(x, n)
% Extend the columns of x to give at least n rows by adding rows of zeros
% symmetrically at the top and bottom.
[r, c] = size(x);
if r < n,
  n1 = floor((n - r)/2);
  n2 = n - r - n1;
  y = [zeros(n1, c); x; zeros(n2, c)];
else y = x;
end
