function y = extend2(x, n)
% function y = extend2(x, n)
% Extend the columns of x to give at least n rows by adding rows of zeros
% symmetrically at the top and bottom.
% Version 2 trims x symmetrically if it has more than n rows.
[r, c] = size(x);
if r < n,
  n1 = floor((n - r)/2);
  n2 = n - r - n1;
  y = [zeros(n1, c); x; zeros(n2, c)];
else
  n1 = ceil((r - n)/2) + 1;
  n2 = n + n1 - 1;
  y = x(n1:n2,:);
end
