% HUFFCHR.M
% Generate tables bits and huffval for the JPEG chrominance AC coefs
% and tables bitsdc and huffvdc for the chrominance DC coefs
% (JPEG Book pp 517-8, Annex K.3.3),

disp('Using default Huffman tables for chrominance DC and AC coefs.')

bits=hex2vec('0 2 1 2 4 4 3 4 7 5 4 4 0 1 2 77');

huffval=hex2vec('0 1 2 3 11 4 5 21 31 6 12 41 51 7 61 71')';
huffval=[huffval; hex2vec('13 22 32 81 8 14 42 91 a1 b1 c1 9 23 33 52 f0')'];
huffval=[huffval; hex2vec('15 62 72 d1 0a 16 24 34 e1 25 f1 17 18 19 1a 26')'];
huffval=[huffval; hex2vec('27 28 29 2a 35 36 37 38 39 3a 43 44 45 46 47 48')'];
huffval=[huffval; hex2vec('49 4a 53 54 55 56 57 58 59 5a 63 64 65 66 67 68')'];
huffval=[huffval; hex2vec('69 6a 73 74 75 76 77 78 79 7a 82 83 84 85 86 87')'];
huffval=[huffval; hex2vec('88 89 8a 92 93 94 95 96 97 98 99 9a a2 a3 a4 a5')'];
huffval=[huffval; hex2vec('a6 a7 a8 a9 aa b2 b3 b4 b5 b6 b7 b8 b9 ba c2 c3')'];
huffval=[huffval; hex2vec('c4 c5 c6 c7 c8 c9 ca d2 d3 d4 d5 d6 d7 d8 d9 da')'];
huffval=[huffval; hex2vec('e2 e3 e4 e5 e6 e7 e8 e9 ea f2 f3 f4 f5 f6 f7 f8')'];
huffval=[huffval; hex2vec('f9 fa')'];

bitsdc=hex2vec('0 3 1 1  1 1 1 1  1 1 1 0  0 0 0 0');

huffvdc=hex2vec('0 1 2 3 4 5 6 7 8 9 a b')';
