function y = ihaar2d(x)

% function y = ihaar2d(x)
% Perform an inverse 2-D Haar transform on x.
% Use [1 1; 1 -1]/2 in order to preserve energy.
% The size of x must be even.

sx = size(x);
t1 = 1:2:sx(1);
t2 = 1:2:sx(2);
ilv1 = [t1  t1+1];
ilv2 = [t2  t2+1];

sz = sx/2;
z1 = 1:sz(1);
z2 = 1:sz(2);

% Reverse:
% y = [x(:,t2)+x(:,t2+1)  x(:,t2)-x(:,t2+1)];
% y = [y(t1,:)+y(t1+1,:); y(t1,:)-y(t1+1,:)] * 0.5;

y(ilv1,:) = [x(z1,:)+x(z1+sz(1),:); x(z1,:)-x(z1+sz(1),:)];
y(:,ilv2) = [y(:,z2)+y(:,z2+sz(2))  y(:,z2)-y(:,z2+sz(2))] * 0.5;

return;
